[PATCH v2 2/2] erofs-utils: tests: add random test for xattrs
Huang Jianan
jnhuang at linux.alibaba.com
Thu Jul 28 22:09:10 AEST 2022
Add random functional check for xattrs.
Signed-off-by: Huang Jianan <jnhuang at linux.alibaba.com>
---
tests/Makefile.am | 3 ++
tests/erofs/020 | 72 +++++++++++++++++++++++++++++++++++++++++++++
tests/erofs/020.out | 2 ++
3 files changed, 77 insertions(+)
create mode 100755 tests/erofs/020
create mode 100644 tests/erofs/020.out
diff --git a/tests/Makefile.am b/tests/Makefile.am
index b85ae89..d486ce3 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -91,6 +91,9 @@ TESTS += erofs/018
# 019 - check extended attribute functionality
TESTS += erofs/019
+# 020 - test random extended attribute functionality for mkfs and fuse
+TESTS += erofs/020
+
EXTRA_DIST = common/rc erofs
clean-local: clean-local-check
diff --git a/tests/erofs/020 b/tests/erofs/020
new file mode 100755
index 0000000..77409dd
--- /dev/null
+++ b/tests/erofs/020
@@ -0,0 +1,72 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0+
+#
+# 020 - check extended attribute functionality
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$(echo $0 | awk '{print $((NF-1))"/"$NF}' FS="/")
+
+# get standard environment, filters and checks
+. "${srcdir}/common/rc"
+
+cleanup()
+{
+ cd /
+ rm -rf $tmp.*
+}
+
+check_xattrs()
+{
+ _scratch_mount 2>>$seqres.full
+
+ # check xattrs
+ for d in $dirs; do
+ xattr1=`getfattr --absolute-names -d $localdir/$d | tail -n+2`
+ xattr2=`getfattr --absolute-names -d $SCRATCH_MNT/$d | tail -n+2`
+ [ "x$xattr1" = "x$xattr2" ] || _fail "-->check xattrs FAILED"
+ done
+
+ _scratch_unmount
+}
+
+_require_erofs
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+echo "QA output created by $seq"
+
+have_attr=`which setfattr`
+[ -z "$have_attr" ] && \
+ _notrun "attr isn't installed, skipped."
+
+if [ -z $SCRATCH_DEV ]; then
+ SCRATCH_DEV=$tmp/erofs_$seq.img
+ rm -f SCRATCH_DEV
+fi
+
+localdir="$tmp/$seq"
+rm -rf $localdir
+mkdir -p $localdir
+
+# set random xattrs
+cp -nR ../ $localdir
+dirs=`ls $localdir`
+for d in $dirs; do
+ for i in `seq $((RANDOM % 20))`; do
+ key=`head -20 /dev/urandom | cksum | cut -f1 -d " "`
+ val="0s"`head -3 /dev/urandom | base64 -w0`
+ setfattr -n user.$key -v $val $localdir/$d
+ done
+done
+
+_scratch_mkfs $localdir >> $seqres.full 2>&1 || _fail "failed to mkfs"
+check_xattrs
+
+FSTYP="erofsfuse"
+check_xattrs
+
+echo Silence is golden
+status=0
+exit 0
diff --git a/tests/erofs/020.out b/tests/erofs/020.out
new file mode 100644
index 0000000..20d7944
--- /dev/null
+++ b/tests/erofs/020.out
@@ -0,0 +1,2 @@
+QA output created by 020
+Silence is golden
--
2.34.1
More information about the Linux-erofs
mailing list